/**==========================================================================

	PC-8001 Device Emulator for Win32 Ver 1.10
	Copyright (C)1993-2010 H.Kanemoto

	This is a free software. You may copy or distribute
	it without any permissions. But there are NO WARRANTY
	of use. Entire risk of use is with you.

	External assembler functions for IBM-PC with VC++ 5.0
	last modified  Apr,4,1998.

;==========================================================================*/
#include "pc-8001.h"
#ifdef _MSC_VER
#include <windows.h>
#include "../N80/N80.h"
#endif
#ifdef __cplusplus
extern "C"
{
#endif
#define export
extern void	_ovl_8020X(LPVOID txt, LPVOID pac, LPVOID font, LPVOID vram, LPVOID palette, DWORD lpitch, DWORD usepcg);
extern void	_ovl_8025X(LPVOID txt, LPVOID pac, LPVOID font, LPVOID vram, LPVOID palette, DWORD lpitch, DWORD usepcg);
extern void	_ovl_4020X(LPVOID txt, LPVOID pac, LPVOID font, LPVOID vram, LPVOID palette, DWORD lpitch, DWORD usepcg);
extern void	_ovl_4025X(LPVOID txt, LPVOID pac, LPVOID font, LPVOID vram, LPVOID palette, DWORD lpitch, DWORD usepcg);
extern void	_cls_graphX(LPVOID vram, DWORD lpitch);
/**--------------------------------------------------------------------------
 **		Text(80x25)`
 **------------------------------------------------------------------------*/
export void blt8025x(int line) {
	LPDWORD	vaddr = (LPDWORD)n80win32.vram_addr;
	int		offset = n80win32.vtbl_vram25[line];
	LPDWORD	vram = &vaddr[offset];

	_ovl_8025X(
		&n80device.attr._textcach[0],
		&n80device.attr._eval_attr[0],
		&n80device.font[0],
		vram,
		&n80device.blt.direct_palette_rgb_fix[0][0],
		n80win32.vram_lpitch,
		select_fnt(line));
}
/**--------------------------------------------------------------------------
 **		Text(80x20)`
 **------------------------------------------------------------------------*/
export void blt8020x(int line) {
	if (line < 20) {
		LPDWORD	vaddr = (LPDWORD)n80win32.vram_addr;
		int		offset = n80win32.vtbl_vram20[line];
		LPDWORD	vram = &vaddr[offset];

		_ovl_8020X(
			&n80device.attr._textcach[0],
			&n80device.attr._eval_attr[0],
			&n80device.font[0],
			vram,
			&n80device.blt.direct_palette_rgb_fix[0][0],
			n80win32.vram_lpitch,
			select_fnt(line));
	}
}
/**--------------------------------------------------------------------------
 **		Text(40x25)`
 **------------------------------------------------------------------------*/
export void blt4025x(int line) {
	LPDWORD	vaddr = (LPDWORD)n80win32.vram_addr;
	int		offset = n80win32.vtbl_vram25[line];
	LPDWORD	vram = &vaddr[offset];

	_ovl_4025X(
		&n80device.attr._textcach[0],
		&n80device.attr._eval_attr[0],
		&n80device.font[0],
		vram,
		&n80device.blt.direct_palette_rgb_fix[0][0],
		n80win32.vram_lpitch,
		select_fnt(line));
}
/**--------------------------------------------------------------------------
 **		Text(40x20)`
 **------------------------------------------------------------------------*/
export void blt4020x(int line) {
	if (line < 20) {
		LPDWORD	vaddr = (LPDWORD)n80win32.vram_addr;
		int		offset = n80win32.vtbl_vram20[line];
		LPDWORD	vram = &vaddr[offset];

		_ovl_4020X(
			&n80device.attr._textcach[0],
			&n80device.attr._eval_attr[0],
			&n80device.font[0],
			vram,
			&n80device.blt.direct_palette_rgb_fix[0][0],
			n80win32.vram_lpitch,
			select_fnt(line));
	}
}
/**--------------------------------------------------------------------------
 **		NA
 **------------------------------------------------------------------------*/
export void bltblankx() {
	int offset = (n80win32.vram_top_offset) * n80win32.vram_pixcel_pitch + n80win32.vram_left_offset;
	LPDWORD	video = (LPDWORD)n80win32.vram_addr;
	LPVOID  vram = &video[offset];
	_cls_graphX(vram, n80win32.vram_lpitch);
}
#ifdef __cplusplus
}	// extern "C"
#endif
