;==============================================================================
;
;	PC-8001 Device Emulator for Win32 Ver 1.10
;	Copyright (C)1993-2007 H.Kanemoto
;
;	This is a free software. You may copy or distribute
;	it without any permissions. But there are NO WARRANTY
;	of use. Entire risk of use is with you.
;
;	External assembler functions for IBM-PC with VC++ 5.0
;	last modified  Aug,18,2007.
;
;==============================================================================
			.586
			.mmx
			.xmm
			.xlist
if @Version gt 510
			.model FLAT
else
_TEXT		SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT		ENDS
_DATA		SEGMENT DWORD USE32 PUBLIC 'DATA'
_DATA		ENDS
CONST		SEGMENT DWORD USE32 PUBLIC 'CONST'
CONST		ENDS
_BSS		SEGMENT DWORD USE32 PUBLIC 'BSS'
_BSS		ENDS
$$SYMBOLS	SEGMENT BYTE USE32 'DEBSYM'
$$SYMBOLS	ENDS
$$TYPES		SEGMENT BYTE USE32 'DEBTYP'
$$TYPES		ENDS
_TLS		SEGMENT DWORD USE32 PUBLIC 'TLS'
_TLS		ENDS
FLAT		GROUP _DATA, CONST, _BSS
			ASSUME	CS: FLAT, DS: FLAT, SS: FLAT
endif
;==============================================================================
_DATA		segment
			align	4
__adj_vtbl	dd	?
__ras_vtbl	dd	?
__cpvram	dd	offset FLAT:__cpvram1
_cpvrams	dd	offset FLAT:__cpvram1
			dd	offset FLAT:__cpvram2
__cpvramdbl	dd	offset FLAT:__cpvramdbl1
_cpvramdbls	dd	offset FLAT:__cpvramdbl1
			dd	offset FLAT:__cpvramdbl2

__simd_lvl	dd	0

__fnt_patX	db	80 dup(?)

_DATA		ends
;==============================================================================
_TEXT		segment
;------------------------------------------------------------------------------
;		void	__cls_graphV (vram,lpitch)
;------------------------------------------------------------------------------
			public	__cls_graphV
__cls_graphV	proc	near
			push	ebp
			mov		ebp,esp
			push	esi
			push	edi
			push	ebx
			;;;;	recieve args
			mov		edi,[ebp+8]					; vram
			mov		ebx,[ebp+12]				; lpitch

			mov		eax,32
			mov		edx,edi
			vxorps	ymm0,ymm0,ymm0

			;;;;	start drawing
			mov		ecx,200						; 200 rasters
_raster_loop:
			rept	80							; 8pixel*80=640pixel/raster
			vmovdqa	ymmword ptr[edi],ymm0		; clear even raster
			vmovdqa	ymmword ptr[edi+ebx],ymm0	; clear odd raster
			add		edi,eax						; ++vram
			endm

			add		edx,ebx
			add		edx,ebx
			dec		ecx
			mov		edi,edx
			jnz		_raster_loop

			;;;;	end of draw
			pop		ebx
			pop		edi
			pop		esi
			pop		ebp
			ret

__cls_graphV	endp
;------------------------------------------------------------------------------
;		int	__blt_sse_mode (mode)
;------------------------------------------------------------------------------
;	mode	0:N/A, 1:MMX, 2:SSE, 3:SSE2, 4:SSE3, 5:SSSE3, 6:SSE4.1 7:SSE4.2
;			8:AVX, 9:AVX2
;------------------------------------------------------------------------------
			public	__blt_simd_level
__blt_simd_level	proc	near
			push	ebp
			mov		ebp,esp
			push	esi
			push	edi
			push	ebx

			mov		eax,[ebp+8]
			mov		DWORD PTR __simd_lvl,eax
			xor		ebx,ebx
			cmp		al,8						; AVX or less
			jbe		@f
			mov		ebx,1						; AVX2 or above
@@:			mov		eax,_cpvrams[ebx*4]
			mov		__cpvram,eax
			mov		eax,_cpvramdbls[ebx*4]
			mov		__cpvramdbl,eax

			;;;;	end of proc
			pop		ebx
			pop		edi
			pop		esi
			pop		ebp
			ret
__blt_simd_level	endp
;------------------------------------------------------------------------------
;		void	__cpvramdbl1/2 (AVX1/AVX2)
;------------------------------------------------------------------------------
__cpvram1	proc	near
			vmovdqa	xmmword ptr[edi],xmm0
			vmovdqa	xmmword ptr[edi+16],xmm1
			ret
__cpvram2	label	near
			vinserti128		ymm0,ymm0,xmm0,0	; ymm0 = ----:xmm0
			vinserti128		ymm0,ymm0,xmm1,1	; ymm0 = xmm1:xmm0
			vmovdqa	ymmword ptr[edi],ymm0		; draw 8 pixels to video ram
			ret
__cpvramdbl1	label	near
			vmovdqa	xmmword ptr[edi],xmm0
			vmovdqa	xmmword ptr[edi+16],xmm2
			vmovdqa	xmmword ptr[edi+ecx],xmm1
			vmovdqa	xmmword ptr[edi+ecx+16],xmm3
			ret
__cpvramdbl2	label	near	; AVX2
			vinserti128		ymm0,ymm0,xmm0,0	; ymm0 = ----:xmm0
			vinserti128		ymm1,ymm1,xmm1,0	; ymm1 = ----:xmm1
			vinserti128		ymm0,ymm0,xmm2,1	; ymm0 = xmm2:xmm0
			vinserti128		ymm1,ymm1,xmm3,1	; ymm1 = xmm3:xmm1
			vmovdqa	ymmword ptr[edi],ymm0		; write 8 pixels(256bit) to video ram
			vmovdqa	ymmword ptr[edi+ecx],ymm1	; write 8 pixels(256bit) to video ram (interlace)
			ret
__cpvram1	endp
;------------------------------------------------------------------------------
;		macro	__adj_pat
;------------------------------------------------------------------------------
;		adjust font pattern according to attribute(pac) and save it
;			IN:		ah:attr al:pat(raw) edi:*pat(cooked) edx:*fnt(raw)
;			OUT:	al:pat(cooked)
;------------------------------------------------------------------------------
__adj_pat	macro
			local	_chk_rev					; general font raster
			local	_chk_end
			test	ah,40h						; check attr erase
			jz		short _chk_rev
			xor		al,al
_chk_rev:	test	ah,20h						; check attr reverse
			jz		short _chk_end
			not		al
_chk_end:
			endm
__adj_top	macro								; top font raster
			local	__end_top
			test	ah,08h						; check attr upper-line
			jz		__end_top
			mov		al,0ffh
__end_top:	__adj_pat
			endm
__adj_bot	macro								; bottom font raster
			local	__end_bot
			test	ah,80h						; check attr under-line
			jz		__end_bot
			mov		al,0ffh
__end_bot:	__adj_pat
			endm

__bit_exp	macro								; expand bit to double
			local	_dbl_off
			shl		bx,2
			sal		al,1
			jnc		_dbl_off
			or		bx,3
_dbl_off:	
			endm
__fnt_exp	macro								; expand 8bit narrow font pattern to 16bit wide
			rept	8
			__bit_exp
			endm
			endm

__fnt_sel	macro								; get pointer to char font
			local	_fnt_core
			local	_fnt_hpcg
			local	_fnt_npcg
			local	_fnt_font
			local	_fnt_exit
			test	BYTE PTR[ebp+32],2			; check use-pcg(chiqlappe) flag
			jz		short _fnt_core
			test	ah,20h						; check attr reverse
			jz		short _fnt_core
			test	BYTE PTR[ebp+32],4			; check block mode
			jz		short _fnt_npcg
			movzx	edx,WORD PTR[ebp+34]		; offset to pcg bank#0..3
			add		ecx,edx
			jmp		short _fnt_npcg
_fnt_core:	test	ah,10h						; check graph char
			jz		_fnt_hpcg
			lea		edx,[edi+2048+ecx]			; pointer to font (graph)
			jmp		short _fnt_exit
_fnt_hpcg:	test	BYTE PTR[ebp+32],1			; check use-pcg(hal) flag
			jz		short _fnt_font
_fnt_npcg:	lea		edx,[edi+4096+ecx]			; pointer to font (pcg)
			jmp		short _fnt_exit
_fnt_font:	lea		edx,[edi+ecx]				; pointer to font (normal)
_fnt_exit:
			endm
;******************************************************************************
;			Graphic (80columns) T/G Mix
;******************************************************************************
__adj_patN	macro								; narrow font single raster
			__adj_pat
			__adj_saveN
			endm
__adj_topN	macro								; narrow font top raster
			__adj_top
			__adj_saveN
			endm
__adj_botN	macro								; narrow font bottom raster
			__adj_bot
			__adj_saveN
			endm
__adj_saveN	macro
			mov		BYTE PTR[edi],al			; save cooked pat
			inc		edi
			mov		al,BYTE PTR[edx]			; get next raw pat
			inc		edx
			endm

__adj_fnt8	macro								; 8 rasters/char (25 lines)
			mov		al,BYTE PTR[edx]
			inc		edx
			__adj_topN
			rept	6
			__adj_patN
			endm
			__adj_botN
			endm

__adj_fnt10	macro								; 10 rasters/char (20 lines)
			xor		al,al
			__adj_topN
			rept	8
			__adj_patN
			endm
			xor		al,al
			__adj_botN
			endm
;------------------------------------------------------------------------------
;		macro	__fntrastN
;------------------------------------------------------------------------------
__fntrastN	macro
			mov		dl,BYTE PTR[esi]			; get font pattern
			pinsrd	xmm6,esi,1	
			__fntdraw							; draw narrow font
			add		edi,ecx
			add		edi,ecx
			pinsrd	xmm5,edi,0					; save vram'
			pextrd	esi,xmm6,1		
			inc		esi							; next pattern
			endm

__fntdraw	macro
			;;;;	copy when bit=1
			__fntbit	80h,0,1,0c0h,80h,0		; b7
			__fntbit	40h,0,1,0d0h,90h,1		; b6
			__fntbit	20h,0,1,0e0h,0a0h,2		; b5
			__fntbit	10h,0,1,0f0h,0b0h,3		; b4
			__fntbit	8h,2,3,0c0h,80h,0		; b3
			__fntbit	4h,2,3,0d0h,90h,1		; b2
			__fntbit	2h,2,3,0e0h,0a0h,2		; b1
			__fntbit	1h,2,3,0f0h,0b0h,3		; b0

			pextrd	edi,xmm5,0					; retrieve vram'
			call	[__cpvramdbl]				; copy to vram
			endm

__fntbit	macro	chk,x1,x2,cp1,cp2,cp3
			local	_bNb
			local	_bNe
			sal		dl,1
			jnc		short _bNb
			insertps	xmm&x1,xmm5,&cp1		; bN (font)
			insertps	xmm&x2,xmm5,&cp2
			jmp		short _bNe
_bNb:		xor		eax,eax
			pinsrd	xmm&x1,eax,&cp3
			pinsrd	xmm&x2,eax,&cp3
_bNe:
			endm
;------------------------------------------------------------------------------
;		void	__ovl_802X (txt[],pac[],font[],vram,pal[],lpitch,pcgon)
;------------------------------------------------------------------------------
;			Overlaying char on graphics
;					____[3]____	____[2]____	____[1]____	____[0]____
;			xmm7	  *txt		  *pac		  *fnt		  *vram
;			xmm6	  pal(RGB)	  lpitch	  
;			xmm5	  color#1	  color#2	  	          *vram'
;------------------------------------------------------------------------------
			public	__ovl_8025V,__ovl_8020V
__ovl_8025V	proc	near
			lea		eax,_adj_8025
			mov		__adj_vtbl,eax
			lea		eax,_ras_8025
			jmp		short @f
__ovl_8020V	label	near
			lea		eax,_adj_8020
			mov		__adj_vtbl,eax
			lea		eax,_ras_8020
@@:			mov		__ras_vtbl,eax

			push	ebp
			mov		ebp,esp
			push	esi
			push	edi
			push	ebx

			;;;;	recieve args
			mov		edi,[ebp+8]					; *txt
			mov		esi,[ebp+12]				; *pac
			pinsrd	xmm7,DWORD PTR[ebp+16],1	; *fnt
			pinsrd	xmm7,DWORD PTR[ebp+20],0	; *vram
			pinsrd	xmm6,DWORD PTR[ebp+24],3	; *palette (font)
			pinsrd	xmm6,DWORD PTR[ebp+28],2	; lpitch
			lea		eax,offset __fnt_patX		; _pat
			pinsrd	xmm4,eax,0
			mov		ecx,80						; col counter
			;;;;	draw columns loop
_col_loop:	pinsrd	xmm6,ecx,0					; save col counter
			mov		al,BYTE PTR[edi]			; ascii = *txt++
			inc		edi
			mov		ah,BYTE PTR[esi]			; attr = *pac++
			inc		esi
			pinsrd	xmm7,edi,3					; save *txt
			pinsrd	xmm7,esi,2					; save *pac
			;;;;	adjust font pointer
			pextrd	edi,xmm7,1					; retrieve *fnt
			movzx	ecx,al						; index of fnt
			shl		ecx,3
			__fnt_sel							; get pointer to char-font
			;;;;	adjust font bit pattern accrding to attribute(pac)
_adj_fnt:	pextrd	esi,xmm4,0					; retrieve *pat
			mov		edi,esi
			jmp		[__adj_vtbl]				; adjust font pattern with attr
_adj_8025	label	near						; width 80,25 font pattern
			__adj_fnt8
			jmp		_txt_color
_adj_8020	label	near						; width 80,20 font pattern
			__adj_fnt10
			;;;;	get font color
_txt_color:	pextrd	edi,xmm6,3					; retrieve color palette
			and		ah,07h						; pac.BRG
			movzx	ecx,ah
			shl		ecx,2
			pinsrd	xmm5,DWORD PTR[edi+ecx],3	; font color [even/odd]
			pinsrd	xmm5,DWORD PTR[edi+32+ecx],2
			;;;;	draw font/graph mix
			pextrd	ecx,xmm6,2					; retrieve lpitch
			pextrd	edi,xmm7,0					; retrieve vram
			pinsrd	xmm5,edi,0					; save vram'
			jmp		[__ras_vtbl]

_ras_8020	label	near
			__fntrastN
			__fntrastN
_ras_8025	label	near
			rept	8
			__fntrastN
			endm

_draw_end:	pextrd	ebx,xmm7,0					; retrieve vram
			add		ebx,32						; next video addr
			pinsrd	xmm7,ebx,0					; save vram
			pextrd	esi,xmm7,2					; retrieve *pac
			pextrd	edi,xmm7,3					; retrieve *txt
			pextrd	ecx,xmm6,0					; retrieve col counter
			dec		ecx
			jnz		_col_loop

			;;;;	end of draw
			pop		ebx
			pop		edi
			pop		esi
			pop		ebp
			ret

__ovl_8025V	endp
;******************************************************************************
;			Graphic (40columns) T/G Mix
;******************************************************************************
__adj_patW	macro								; wide font single raster
			__adj_pat
			__adj_saveW
			endm
__adj_topW	macro								; wide font single top raster
			__adj_top
			__adj_saveW
			endm
__adj_botW	macro								; wide font single bottom raster
			__adj_bot
			__adj_saveW
			endm
__adj_saveW	macro
			xor		ebx,ebx						; expand narrow pattern to wide
			__fnt_exp
			mov		BYTE PTR[edi],bh			; *pat2++ = pat (left)
			inc		edi
			mov		BYTE PTR[edi],bl			; *pat2++ = pat (right)
			inc		edi
			mov		al,BYTE PTR[edx]			; pat = *fnt++
			inc		edx
			endm

__adj_fnt8W	macro
			mov		al,BYTE PTR[edx]
			inc		edx
			__adj_topW
			rept	6
			__adj_patW
			endm
			__adj_botW
			endm

__adj_fnt10W	macro
			xor		al,al
			__adj_topW
			rept	8
			__adj_patW
			endm
			xor		al,al
			__adj_botW
			endm
;------------------------------------------------------------------------------
;		macro	__fntrastW
;------------------------------------------------------------------------------
__fntrastW	macro
			mov		dl,BYTE PTR[esi]			; get font pattern
			pinsrd	xmm6,esi,1					; save *pat
			__fntdraw							; draw wide font [0] - left side
			add		edi,32
			pinsrd	xmm5,edi,0					; save vram'
			mov		dl,BYTE PTR[esi+1]
			__fntdraw							; draw wide font [1] - right side
			add		edi,ecx
			add		edi,ecx
			sub		edi,32
			pinsrd	xmm5,edi,0					; save vram'
			pextrd	esi,xmm6,1					; retrieve *pat
			inc		esi							; next pattern
			inc		esi

			endm
;------------------------------------------------------------------------------
;		void	__ovl_402X (txt[],pac[],font[],vram,palette,lpitch,pcgon)
;------------------------------------------------------------------------------
			public	__ovl_4025V,__ovl_4020V
__ovl_4025V	proc	near
			lea		eax,_adj_4025
			mov		__adj_vtbl,eax
			lea		eax,_ras_4025
			jmp		short @f
__ovl_4020V	label	near
			lea		eax,_adj_4020
			mov		__adj_vtbl,eax
			lea		eax,_ras_4020
@@:			mov		__ras_vtbl,eax

			push	ebp
			mov		ebp,esp
			push	esi
			push	edi
			push	ebx

			;;;;	recieve args
			mov		edi,[ebp+8]					; *txt
			mov		esi,[ebp+12]				; *pac
			pinsrd	xmm7,DWORD PTR[ebp+16],1	; *fnt
			pinsrd	xmm7,DWORD PTR[ebp+20],0	; *vram
			pinsrd	xmm6,DWORD PTR[ebp+24],3	; *palette (font)
			pinsrd	xmm6,DWORD PTR[ebp+28],2	; lpitch
			lea		eax,offset __fnt_patX		; _pat
			pinsrd	xmm4,eax,0
			mov		ecx,40						; col counter
			;;;;	draw columns loop
_col_loop:	pinsrd	xmm6,ecx,0					; save col counter
			mov		al,BYTE PTR[edi]			; ascii = *txt++
			inc		edi
			inc		edi
			mov		ah,BYTE PTR[esi]			; attr = *pac++
			inc		esi
			inc		esi
			pinsrd	xmm7,edi,3					; save *txt
			pinsrd	xmm7,esi,2					; save *pac
			;;;;	adjust font pointer
			pextrd	edi,xmm7,1					; retrieve *fnt
			movzx	ecx,al						; index of fnt
			shl		ecx,3
			__fnt_sel							; get pointer to char-font
			;;;;	adjust font bit pattern accrding to attribute(pac)
_adj_fnt:	pextrd	esi,xmm4,0					; retrieve *pat
			mov		edi,esi
			jmp		[__adj_vtbl]				; adjust font pattern with attr
_adj_4025	label	near						; width 40,25 font pattern
			__adj_fnt8W
			jmp		_txt_color
_adj_4020	label	near						; width 40,20 font pattern
			__adj_fnt10W
			;;;;	get color
_txt_color:	pextrd	edi,xmm6,3					; retrieve color palette
			and		ah,07h						; pac.BRG
			movzx	ecx,ah
			shl		ecx,2
			pinsrd	xmm5,DWORD PTR[edi+ecx],3	; font color [even/odd]
			pinsrd	xmm5,DWORD PTR[edi+32+ecx],2
			;;;;	draw font/graph mix
			pextrd	ecx,xmm6,2					; retrieve lpitch
			pextrd	edi,xmm7,0					; retrieve vram
			pinsrd	xmm5,edi,0					; save vram'
			jmp		[__ras_vtbl]

_ras_4020	label	near
			__fntrastW
			__fntrastW
_ras_4025	label	near
			rept	8
			__fntrastW
			endm

_draw_end:	pextrd	ebx,xmm7,0					; retrieve vram
			add		ebx,64						; next video addr
			pinsrd	xmm7,ebx,0					; save vram
			pextrd	esi,xmm7,2					; retrieve *pac
			pextrd	edi,xmm7,3					; retrieve *txt
			pextrd	ecx,xmm6,0					; retrieve col counter
			dec		ecx
			jnz		_col_loop

			;;;;	end of draw
			pop		ebx
			pop		edi
			pop		esi
			pop		ebp
			ret

__ovl_4025V	endp
;------------------------------------------------------------------------------
_TEXT		ends
;==============================================================================
			end
