;==============================================================================
;
;	PC-8001 Device Emulator for Win32 Ver 1.10
;	Copyright (C)1993-2007 H.Kanemoto
;
;	This is a free software. You may copy or distribute
;	it without any permissions. But there are NO WARRANTY
;	of use. Entire risk of use is with you.
;
;	External assembler functions for IBM-PC with VC++ 5.0
;	last modified  Aug,18,2007.
;
;==============================================================================
			.586
			.mmx
			.xmm
			.xlist
if @Version gt 510
			.model FLAT
else
_TEXT		SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT		ENDS
_DATA		SEGMENT DWORD USE32 PUBLIC 'DATA'
_DATA		ENDS
CONST		SEGMENT DWORD USE32 PUBLIC 'CONST'
CONST		ENDS
_BSS		SEGMENT DWORD USE32 PUBLIC 'BSS'
_BSS		ENDS
$$SYMBOLS	SEGMENT BYTE USE32 'DEBSYM'
$$SYMBOLS	ENDS
$$TYPES		SEGMENT BYTE USE32 'DEBTYP'
$$TYPES		ENDS
_TLS		SEGMENT DWORD USE32 PUBLIC 'TLS'
_TLS		ENDS
FLAT		GROUP _DATA, CONST, _BSS
			ASSUME	CS: FLAT, DS: FLAT, SS: FLAT
endif
;==============================================================================
_DATA		segment
			align	4
__adj_vtbl	dd	?
__ras_vtbl	dd	?

__fnt_pat	db	80 dup(?)

_DATA		ends
;==============================================================================
_TEXT		segment
;------------------------------------------------------------------------------
;		void	__cls_graphX (vram,lpitch)
;------------------------------------------------------------------------------
			public	__cls_graphX
__cls_graphX	proc	near
			push	ebp
			mov		ebp,esp
			push	esi
			push	edi
			push	ebx
			;;;;	recieve args
			mov		edi,[ebp+8]					; vram
			mov		ebx,[ebp+12]				; lpitch

			mov		eax,32
			mov		edx,edi						; save vram
			xor		ecx,ecx						; zero clear xmm0 reg
			movd	xmm0,ecx

			;;;;	start drawing
			mov		ecx,200						; 200 rasters
_raster_loop:
			rept	80							; 8pixel*80=640pixel/raster
			movdqa	[edi],xmm0					; clear even raster
			movdqa	[edi+16],xmm0
			movdqa	[edi+ebx],xmm0				; clear odd raster
			movdqa	[edi+ebx+16],xmm0
			add		edi,eax						; ++vram
			endm

			add		edx,ebx						; vram next
			add		edx,ebx
			mov		edi,edx
			dec		ecx
			jnz		_raster_loop

			;;;;	end of draw
			pop		ebx
			pop		edi
			pop		esi
			pop		ebp
			ret

__cls_graphX	endp
;------------------------------------------------------------------------------
;		void	__fill_bdr ()
;------------------------------------------------------------------------------
			public	__fill_bdr
__fill_bdr	proc	near
			push	ebp
			mov		ebp,esp
			push	esi
			push	edi
			push	ebx
			;;;;	recieve args
			movd	xmm7,DWORD PTR[ebp+8]		; vram
			mov		ecx,DWORD PTR[ebp+12]		; width
			mov		eax,DWORD PTR[ebp+16]		; rows
			movd	xmm0,DWORD PTR[ebp+20]		; bd color (even)
			movd	xmm2,DWORD PTR[ebp+24]		; bd color (odd)
			movd	xmm4,DWORD PTR[ebp+28]		; lpitch

			shr		eax,1						; row / 2 = raster count
			shr		ecx,3						; width / 8 = col count
			movd	xmm6,ecx					; save col
			mov		ecx,32						; vram delta
			pslldq	xmm0,4						; dup 4 pixels colors (even)
			movshdup	xmm1,xmm0
			movddup	xmm0,xmm1
			pslldq	xmm2,4						; dup 4 pixels colors (odd)
			movshdup	xmm3,xmm2
			movddup	xmm2,xmm3
			movd	edx,xmm4					; retrieve lpitch

			;;;;	start drawing
_ras_loop:	movd	xmm5,eax					; save raster
			movd	edi,xmm7					; retrieve vram
			movd	eax,xmm6					; retrieve col
_col_loop:	movd	xmm3,eax					; save col'
			movdqa	[edi],xmm0					; fill even raster (8 pixels)
			movdqa	[edi+16],xmm0
			movdqa	[edi+edx],xmm2				; fill odd raster (8 pixels)
			movdqa	[edi+edx+16],xmm2

			add		edi,ecx						; ++vram
			movd	eax,xmm3					; retrieve col'
			dec		eax
			jnz		_col_loop

			paddd	xmm7,xmm4					; next raster
			paddd	xmm7,xmm4
			movd	eax,xmm5					; retrieve raster
			dec		eax
			jnz		_ras_loop

			;;;;	end of draw
			pop		ebx
			pop		edi
			pop		esi
			pop		ebp
			ret

__fill_bdr	endp
;------------------------------------------------------------------------------
;		macro	__adj_pat
;------------------------------------------------------------------------------
;		adjust font pattern according to attribute(pac) and save it
;			IN:		ah:attr al:pat(raw) edi:*pat(cooked) edx:*fnt(raw)
;			OUT:	al:pat(cooked)
;------------------------------------------------------------------------------
__adj_pat	macro
			local	_chk_rev					; general font raster
			local	_chk_end
			test	ah,40h						; check attr erase
			jz		short _chk_rev
			xor		al,al
_chk_rev:	test	ah,20h						; check attr reverse
			jz		short _chk_end
			not		al
_chk_end:
			endm
__adj_top	macro								; top font raster
			local	__end_top
			test	ah,08h						; check attr upper-line
			jz		__end_top
			mov		al,0ffh
__end_top:	__adj_pat
			endm
__adj_bot	macro								; bottom font raster
			local	__end_bot
			test	ah,80h						; check attr under-line
			jz		__end_bot
			mov		al,0ffh
__end_bot:	__adj_pat
			endm

__bit_exp	macro								; expand bit to double
			local	_dbl_off
			shl		bx,2
			sal		al,1
			jnc		_dbl_off
			or		bx,3
_dbl_off:	
			endm
__fnt_exp	macro								; expand 8bit narrow font pattern to 16bit wide
			rept	8
			__bit_exp
			endm
			endm

__fnt_sel	macro								; get pointer to char font
			local	_fnt_core
			local	_fnt_hpcg
			local	_fnt_npcg
			local	_fnt_font
			local	_fnt_exit
			test	BYTE PTR[ebp+32],2			; check use-pcg(chiqlappe) flag
			jz		short _fnt_core
			test	ah,20h						; check attr reverse
			jz		short _fnt_core
			test	BYTE PTR[ebp+32],4			; check block mode
			jz		short _fnt_npcg
			movzx	edx,WORD PTR[ebp+34]		; offset to pcg bank#0..3
			add		ecx,edx
			jmp		short _fnt_npcg
_fnt_core:	test	ah,10h						; check graph char
			jz		_fnt_hpcg
			lea		edx,[edi+2048+ecx]			; pointer to font (graph)
			jmp		short _fnt_exit
_fnt_hpcg:	test	BYTE PTR[ebp+32],1			; check use-pcg(hal) flag
			jz		short _fnt_font
_fnt_npcg:	lea		edx,[edi+4096+ecx]			; pointer to font (pcg)
			jmp		short _fnt_exit
_fnt_font:	lea		edx,[edi+ecx]				; pointer to font (normal)
_fnt_exit:
			endm
;******************************************************************************
;			Graphic (80columns) T/G Mix
;******************************************************************************
__adj_patN	macro								; narrow font single raster
			__adj_pat
			__adj_saveN
			endm
__adj_topN	macro								; narrow font top raster
			__adj_top
			__adj_saveN
			endm
__adj_botN	macro								; narrow font bottom raster
			__adj_bot
			__adj_saveN
			endm
__adj_saveN	macro
			mov		BYTE PTR[edi],al			; save cooked pat
			inc		edi
			mov		al,BYTE PTR[edx]			; get next raw pat
			inc		edx
			endm

__adj_fnt8	macro								; 8 rasters/char (25 lines)
			mov		al,BYTE PTR[edx]
			inc		edx
			__adj_topN
			rept	6
			__adj_patN
			endm
			__adj_botN
			endm

__adj_fnt10	macro								; 10 rasters/char (20 lines)
			xor		al,al
			__adj_topN
			rept	8
			__adj_patN
			endm
			xor		al,al
			__adj_botN
			endm
;------------------------------------------------------------------------------
;		macro	__fntrastN
;------------------------------------------------------------------------------
__fntrastN	macro
			mov		dl,BYTE PTR[esi]			; get font pattern
			movd	xmm3,esi
			__fntdraw							; draw narrow font
			add		edi,ecx
			add		edi,ecx
			movd	xmm5,edi					; save vram'
			movd	esi,xmm3
			inc		esi							; next pattern

			endm

__fntdraw	macro
			;;;;	copy when bit=1
			__fntbit	80h,0					; b7
			__fntbit	40h,4					; b6
			__fntbit	20h,8					; b5
			__fntbit	10h,12					; b4
			__fntbit	8h,16					; b3
			__fntbit	4h,20					; b2
			__fntbit	2h,24					; b1
			__fntbit	1h,28					; b0
			endm

__fntbit	macro	chk,cp1
			local	_bNb
			local	_bNe
			sal		dl,1
			jnc		short _bNb
			mov		eax,DWORD PTR[ebp-16]
			mov		ebx,DWORD PTR[ebp-20]
			jmp		short _bNe
_bNb:		xor		eax,eax
			mov		ebx,eax
_bNe:		movd	edi,xmm5
			mov		DWORD PTR[edi+cp1],eax
			mov		DWORD PTR[edi+ecx+cp1],ebx
			endm
;------------------------------------------------------------------------------
;		void	__ovl_802X (txt[],pac[],font[],vram,pal[],lpitch,pcgon,gvram,pal2[])
;------------------------------------------------------------------------------
;			Overlaying char on graphics
;					____[3]____	____[2]____	____[1]____	____[0]____
;			xmm7	  *txt		  *pac		  *fnt		  *vram
;			xmm6	  pal(RGB)	  lpitch	  
;			xmm5	  color#1	  color#2	  			  *vram'
;------------------------------------------------------------------------------
			public	__ovl_8025X,__ovl_8020X
__ovl_8025X	proc	near
			lea		eax,_adj_8025
			mov		__adj_vtbl,eax
			lea		eax,_ras_8025
			jmp		short @f
__ovl_8020X	label	near
			lea		eax,_adj_8020
			mov		__adj_vtbl,eax
			lea		eax,_ras_8020
@@:			mov		__ras_vtbl,eax

			push	ebp
			mov		ebp,esp
			push	esi
			push	edi
			push	ebx
			;;;;	alloc local variables area
			;;;;	-16:color #1, -20:color #2
			sub		esp,8

			;;;;	recieve args
			mov		edi,[ebp+8]					; *txt
			mov		esi,[ebp+12]				; *pac
			movd	xmm7,DWORD PTR[ebp+16]		; *fnt
			movd	xmm6,DWORD PTR[ebp+20]		; vram
			movd	xmm0,DWORD PTR[ebp+24]		; palette (font)
			lea		eax,offset __fnt_pat		; _pat
			movd	xmm4,eax
			mov		ecx,80						; col counter
			;;;;	draw columns loop
_col_loop:	push	ecx							; save col counter
			mov		al,BYTE PTR[edi]			; ascii = *txt++
			inc		edi
			movd	xmm2,edi					; save *txt
			mov		ah,BYTE PTR[esi]			; attr = *pac++
			inc		esi
			movd	xmm1,esi					; save *pac
			;;;;	adjust font pointer
			movd	edi,xmm7					; retrieve *fnt
			movzx	ecx,al						; index of fnt
			shl		ecx,3
			__fnt_sel							; get pointer to char-font
			;;;;	adjust font bit pattern accrding to attribute(pac)
_adj_802x:	movd	esi,xmm4					; retrieve *pat
			mov		edi,esi
			jmp		[__adj_vtbl]
_adj_8025	label	near
			__adj_fnt8
			jmp		_txt_color
_adj_8020	label	near
			__adj_fnt10
			;;;;	get font color
_txt_color:	movd	edi,xmm0					; retrieve color palette
			and		ah,07h						; pac.BRG
			movzx	ecx,ah
			shl		ecx,2
			mov		eax,DWORD PTR[edi+ecx]		; font color #1,#2
			mov		DWORD PTR[ebp-16],eax
			mov		eax,DWORD PTR[edi+32+ecx]
			mov		DWORD PTR[ebp-20],eax
			;;;;	draw font/graph mix
			mov		ecx,DWORD PTR[ebp+28]		; retrieve lpitch
			movd	edi,xmm6					; retrieve vram
			movd	xmm5,edi					; save vram'
			jmp		[__ras_vtbl]

_ras_8020	label	near
			__fntrastN
			__fntrastN
_ras_8025	label	near
			rept	8
			__fntrastN
			endm

_draw_end:	movd	ebx,xmm6					; retrieve vram
			add		ebx,32						; next video addr
			movd	xmm6,ebx					; save vram
			movd	esi,xmm1					; retrieve *pac
			movd	edi,xmm2					; retrieve *txt
			pop		ecx							; retrieve col counter
			dec		ecx
			jnz		_col_loop

			;;;;	end of draw
			add		esp,8						; release local variables
			pop		ebx
			pop		edi
			pop		esi
			pop		ebp
			ret

__ovl_8025X	endp
;******************************************************************************
;			Graphic (40columns) T/G Mix
;******************************************************************************
__adj_patW	macro								; wide font single raster
			__adj_pat
			__adj_saveW
			endm
__adj_topW	macro								; wide font single top raster
			__adj_top
			__adj_saveW
			endm
__adj_botW	macro								; wide font single bottom raster
			__adj_bot
			__adj_saveW
			endm
__adj_saveW	macro
			xor		ebx,ebx						; expand narrow pattern to wide
			__fnt_exp
			mov		BYTE PTR[edi],bh			; *pat2++ = pat (left)
			inc		edi
			mov		BYTE PTR[edi],bl			; *pat2++ = pat (right)
			inc		edi
			mov		al,BYTE PTR[edx]			; pat = *fnt++
			inc		edx
			endm

__adj_fnt8W	macro
			mov		al,BYTE PTR[edx]
			inc		edx
			__adj_topW
			rept	6
			__adj_patW
			endm
			__adj_botW
			endm

__adj_fnt10W	macro
			xor		al,al
			__adj_topW
			rept	8
			__adj_patW
			endm
			xor		al,al
			__adj_botW
			endm
;------------------------------------------------------------------------------
;		macro	__fntrastW
;------------------------------------------------------------------------------
__fntrastW	macro
			mov		dl,BYTE PTR[esi]			; get font pattern
			movd	xmm3,esi
			__fntdraw							; draw wide font [0] - left side
			add		edi,32
			movd	xmm5,edi					; save vram'
			mov		dl,BYTE PTR[esi+1]
			__fntdraw							; draw wide font [1] - right side
			add		edi,ecx
			add		edi,ecx
			sub		edi,32
			movd	xmm5,edi					; save vram'
			movd	esi,xmm3
			inc		esi							; next pattern
			inc		esi

			endm
;------------------------------------------------------------------------------
;		void	__ovl_402X (txt[],pac[],font[],vram,palette,lpitch,pcgon)
;------------------------------------------------------------------------------
			public	__ovl_4025X,__ovl_4020X
__ovl_4025X	proc	near
			lea		eax,_adj_4025
			mov		__adj_vtbl,eax
			lea		eax,_ras_4025
			jmp		short @f
__ovl_4020X	label	near
			lea		eax,_adj_4020
			mov		__adj_vtbl,eax
			lea		eax,_ras_4020
@@:			mov		__ras_vtbl,eax

			push	ebp
			mov		ebp,esp
			push	esi
			push	edi
			push	ebx
			;;;;	alloc local variables area
			;;;;	-16:color #1, -20:color #2
			sub		esp,8

			;;;;	recieve args
			mov		edi,[ebp+8]					; *txt
			mov		esi,[ebp+12]				; *pac
			movd	xmm7,DWORD PTR[ebp+16]		; *fnt
			movd	xmm6,DWORD PTR[ebp+20]		; vram
			movd	xmm0,DWORD PTR[ebp+24]		; palette (font)
			lea		eax,offset __fnt_pat		; _pat
			movd	xmm4,eax
			mov		ecx,40						; col counter
			;;;;	draw columns loop
_col_loop:	push	ecx							; save col counter
			mov		al,BYTE PTR[edi]			; ascii = *txt++
			inc		edi
			inc		edi
			movd	xmm2,edi					; save *txt
			mov		ah,BYTE PTR[esi]			; attr = *pac++
			inc		esi
			inc		esi
			movd	xmm1,esi					; save *pac
			;;;;	adjust font pointer
			movd	edi,xmm7					; retrieve *fnt
			movzx	ecx,al						; index of fnt
			shl		ecx,3
			__fnt_sel							; get pointer to char-font
			;;;;	adjust font bit pattern accrding to attribute(pac)
_vid_pix:	movd	esi,xmm4					; retrieve *pat
			mov		edi,esi
			jmp		[__adj_vtbl]
_adj_4025	label	near
			__adj_fnt8W
			jmp		_txt_color
_adj_4020	label	near
			__adj_fnt10W
			;;;;	get color
_txt_color:	movd	edi,xmm0					; retrieve color palette
			and		ah,07h						; pac.BRG
			movzx	ecx,ah
			shl		ecx,2
			mov		eax,DWORD PTR[edi+ecx]		; color #1,#2
			mov		DWORD PTR[ebp-16],eax
			mov		eax,DWORD PTR[edi+32+ecx]
			mov		DWORD PTR[ebp-20],eax
			;;;;	draw font/graph
			mov		ecx,DWORD PTR[ebp+28]		; retrieve lpitch
			movd	edi,xmm6					; retrieve vram
			movd	xmm5,edi					; save vram'
			jmp		[__ras_vtbl]

_ras_4020	label	near
			__fntrastW
			__fntrastW
_ras_4025	label	near
			rept	8
			__fntrastW
			endm

_draw_end:	movd	ebx,xmm6					; retrieve vram
			add		ebx,64						; next video addr
			movd	xmm6,ebx					; save vram
			movd	esi,xmm1					; retrieve *pac
			movd	edi,xmm2					; retrieve *txt
			pop		ecx							; retrieve col counter
			dec		ecx
			jnz		_col_loop

			;;;;	end of draw
			add		esp,8						; release local variables
			pop		ebx
			pop		edi
			pop		esi
			pop		ebp
			ret

__ovl_4025X	endp
;------------------------------------------------------------------------------
_TEXT		ends
;==============================================================================
			end
